import{__assign,__extends,__spreadArray}from"tslib";import"../../CommonImports";import"../../Core/core.css";import"./Dropdown.css";import*as React from"react";import{ObservableArray,ObservableLike,ObservableValue}from"../../Core/Observable";import{TimerManagement}from"../../Core/TimerManagement";import*as Utils_Accessibility from"../../Core/Util/Accessibility";import{format}from"../../Core/Util/String";import{FilteredListSelection,renderListCell}from"../../List";import{getListBoxItemsValue,getUnselectableRanges,ListBoxItemType,wrapListBoxItems}from"../../ListBox";import{ItemsObserver,Observer}from"../../Observer";import*as Resources from"../../Resources.Dropdown";import{SimpleTableCell}from"../../Table";import{css}from"../../Util";import{DropdownSelection}from"../../Utilities/DropdownSelection";import{getItemsValue}from"../../Utilities/Provider";import{DropdownCallout}from"./DropdownCallout";import{DropdownExpandableTextField}from"./DropdownExpandableTextField";var announcementInterval,Dropdown=function(n){function e(e){var A=n.call(this,e)||this,t=(A.expandable=React.createRef(),A.expandableContainer=React.createRef(),A.filterText=new ObservableValue(""),A.collapse=function(){A.expandable.current&&A.expandable.current.collapse()},A.expand=function(){A.expandable.current&&A.expandable.current.expand()},A.onDismiss=function(){A.expandable.current&&A.expandable.current.collapse()},A.onExpand=function(){A.props.onExpand&&A.props.onExpand(),A.updateFilteredItems(),A.state.expanded.value=!0},A.onCollapse=function(){A.props.onCollapse&&A.props.onCollapse(),A.state.expanded.value=!1},A.onActivate=function(e,t){var r;e.defaultPrevented||"keydown"!==e.type||((r=!A.props.enforceSingleSelect&&A.state.filteredSelection.multiSelect)?A.state.filteredSelection.toggle(A.state.filteredItems.value.indexOf(t),A.state.filteredSelection.alwaysMerge,r):A.state.filteredSelection.select(A.state.filteredItems.value.indexOf(t),1,A.state.filteredSelection.alwaysMerge,r),A.onSelect(e,t))},A.onFilterTextChanged=function(e,t){A.filterText.value=t,A.debouncedUpdateFilteredItems()},A.onSelect=function(e,t){var r=A.props,n=r.dismissOnSelect,r=r.onSelect,l=A.parentSelection;r&&r(e,t),(void 0!==n?n:0<l.value.length&&(A.props.enforceSingleSelect||!l.multiSelect)&&!l.selectOnFocus)&&A.onDismiss()},A.selectionChanged=function(e,t){return A.state.filteredSelection.selectionChanged(e,t),!0},A.renderCallout=function(e,t,r,n,l,i,o){var a=A.props,s=a.actions,d=a.ariaLabel,c=a.calloutContentClassName,p=a.columns,m=a.containerClassName,u=a.filterPlaceholderText,f=a.filteredNoResultsText,x=a.getUnselectableRanges,h=a.items,I=a.loading,g=a.noItemsText,b=a.onFilterTextChanged,v=a.onToggle,T=a.portalProps,y=a.renderItem,C=a.renderBeforeContent,S=a.searching,w=a.showChecksColumn,L=a.showFilterBox,B=a.showItemsWhileSearching,F=a.showTree,a=a.userFilteredItems,R=A.props.width,D=(void 0===R&&A.expandableContainer.current&&(D=null!=(D=A.props.minCalloutWidth)?D:100,R=Math.max(A.expandableContainer.current.clientWidth,D)),A.state),O=D.filteredItems,_=D.filterText,s={actions:s,anchorElement:r,anchorOffset:n,anchorOrigin:l,anchorPoint:i,ariaLabel:d,calloutContentClassName:c,columns:p,containerClassName:m,dropdownOrigin:o,filteredItems:O,filteredNoResultsText:f,selection:D.filteredSelection,filterPlaceholderText:u,filterText:_,getUnselectableRanges:x,id:t,items:h,loading:I,noItemsText:g,onActivate:A.onActivate,onFilterTextChanged:function(e,t){b&&b(e,t),A.onFilterTextChanged&&A.onFilterTextChanged(e,t)},onDismiss:A.onDismiss,onSelect:A.onSelect,onToggle:v,portalProps:T,renderBeforeContent:C,renderItem:y,searching:S,showChecksColumn:w,showItemsWhileSearching:B,showFilterBox:L,showTree:F,updateFilteredItems:A.updateFilteredItems,userFilteredItems:a,width:R};return A.props.renderCallout(s)},A.updateFilteredItems=function(){return updateFilteredItems(A.props,A.state),!0},A.debouncedUpdateFilteredItems=function(){updateFilteredItems(A.props,A.state)},A.parentSelection=e.selection||new DropdownSelection,wrapListBoxItems(e.items)),r=getListBoxItemsValue(t||e.items);return A.timerManagement=new TimerManagement,A.state={expanded:new ObservableValue(!1),filteredItems:new ObservableArray(__spreadArray([],r,!0)),filteredSelection:new FilteredListSelection(A.parentSelection),filterText:A.filterText,props:e,wrappedItems:t},A}return __extends(e,n),e.getDerivedStateFromProps=function(e,t){return e.userFilteredItems===t.props.userFilteredItems&&e.items===t.props.items||updateFilteredItems(e,t),__assign(__assign({},t),{props:e,wrappedItems:wrapListBoxItems(e.items)})},e.prototype.componentDidMount=function(){this.props.filterThrottleWait&&(this.debouncedUpdateFilteredItems=this.timerManagement.debounce(this.debouncedUpdateFilteredItems,this.props.filterThrottleWait))},e.prototype.render=function(){var e=this,t=this.props,r=t.ariaLabel,n=t.ariaLabelledBy,l=t.ariaDescribedBy,i=t.autoSelect,o=t.className,a=t.disabled,s=t.enforceSingleSelect,d=t.excludeTabStop,c=t.inputId,p=t.items,m=t.placeholder,u=t.renderExpandable,f=t.renderSelectedItems,x=t.role,h=t.showPrefix,I=t.required,t={observableValue:this.parentSelection,filter:this.selectionChanged};return React.createElement(ItemsObserver,{getUnselectableRanges:this.props.getUnselectableRanges,items:p,selection:this.parentSelection},React.createElement(Observer,{selection:t},function(){return u({ariaLabel:r,ariaLabelledBy:n,ariaDescribedBy:l,autoSelect:i,className:css(o,"bolt-dropdown-expandable"),containerRef:e.expandableContainer,disabled:a,enforceSingleSelect:s,excludeTabStop:d,inputId:c,placeholder:m,onCollapse:e.onCollapse,onExpand:e.onExpand,expandableRef:e.expandable,renderCallout:e.renderCallout,items:getListBoxItemsValue(e.state.wrappedItems||p),role:x,renderSelectedItems:f,selection:e.parentSelection,showPrefix:h,required:I})}))},e.prototype.focus=function(){this.expandable.current&&this.expandable.current.focus()},e.defaultProps={filterByText:!0,filterItem:filterItemByText,getUnselectableRanges:getUnselectableRanges,renderCallout:DropdownCallout,renderExpandable:DropdownExpandableTextField,renderSelectedItems:renderDropdownSelectedItemText},e}(React.Component);function filterItemByText(e,t){return!(!t.text||t.type===ListBoxItemType.Header||t.type===ListBoxItemType.Divider||t.type===ListBoxItemType.Loading)&&-1!==t.text.toLowerCase().indexOf(e.toLowerCase())}function renderDropdownSelectedItemText(e,t){t=t[e.value[0].beginIndex],t=t&&t.text||"";return t=1<e.selectedCount?"".concat(t," (+").concat(e.selectedCount-1,")"):t}function updateFilteredItems(t,r){announcementInterval&&clearTimeout(announcementInterval);var e=r.filteredSelection,n=r.filterText,l=[],i=getListBoxItemsValue(r.wrappedItems||t.items),o=i;if(t.userFilteredItems){var o=getItemsValue(t.userFilteredItems),a=t.userFilteredItemsIndexMap&&t.userFilteredItemsIndexMap.value;if(a)l=a;else for(var s=0;s<t.userFilteredItems.length;s++)!function(t){var e=i.findIndex(function(e){return e.id===o[t].id});l.push(e)}(s)}for(t.filterByText&&n.value&&(a=filterItems(o,n.value,l,t.filterItem),o=a.filteredItems,l=a.filteredIndexMap);o.length&&o[0].type===ListBoxItemType.Divider;)o.shift(),l.shift();return announcementInterval=setTimeout(function(){var e;ObservableLike.getValue(t.searching)||ObservableLike.getValue(t.loading)||!r.expanded.value||(n.value?(e=Resources.NoFilterResults,t.filteredNoResultsText&&(e=ObservableLike.getValue(t.filteredNoResultsText)),Utils_Accessibility.announce(0<o.length?format(Resources.AnnounceFilterResultCount,o.length):e,!0)):0===o.length&&t.noItemsText?Utils_Accessibility.announce(t.noItemsText,!0):0<o.length&&Utils_Accessibility.announce(format(Resources.AnnounceItemCount,o.length)))},500),e.updateFilteredSelection(l,!t.enforceSingleSelect&&void 0),r.filteredItems.value=o,!0}function filterItems(e,t,r,n){void 0===r&&(r=[]),void 0===n&&(n=filterItemByText);var l=[],i=[],o=[];if(t)for(var a=void 0,s=-1,d=void 0,c=-1,p=0,m=e.length;p<m;p++){var u,f=e[p],x=r.length?r[p]:p;f.type===ListBoxItemType.Header?(a=f,s=x):f.type===ListBoxItemType.Divider?(d=f,c=x):!(u=n(t,f,e))&&f.type!==ListBoxItemType.Loading||(d&&d.groupId===f.groupId&&(l.push(d),i.push(c),d=void 0),a&&a.groupId===f.groupId&&(l.push(a),i.push(s),a=void 0),l.push(f),i.push(x),o.push(Array.isArray(u)?u:[]))}return{filteredItems:l,filteredIndexMap:i,filterMatches:o}}function filterTreeItems(e,t,r,n,l){void 0===l&&(l=filterMatchedItemByListboxType);for(var t=filterItems(e,t,r=void 0===r?[]:r,n=void 0===n?filterItemByText:n),r=t.filteredIndexMap,n=t.filteredItems.find(l),i={},o=0,a=r;o<a.length;o++){for(var s=e[f=a[o]],d=s.parent;d;)(i[e.indexOf(d)]=d).expanded=!0,d=d.parent;i[f]=s}for(var c=[],p=[],m=0,u=Object.keys(i);m<u.length;m++){var f,x=u[m],x=i[f=Number(x)];c.push(f),p.push(x)}return[{filteredIndexMap:c,filteredItems:p,filterMatches:[]},n?e.indexOf(n):-1]}function filterMatchedItemByListboxType(e){return!e.type||e.type===ListBoxItemType.Row}function renderHighlightedText(e,t,r,n,l){var i=n;return l&&n.text&&(i=__assign(__assign({},n),{textNode:getHighlightedText(n.text,l)})),React.createElement(SimpleTableCell,{className:css(r.className,n.className,n.type===ListBoxItemType.Header&&"bolt-list-box-header"),columnIndex:t,key:t,tableColumn:r},React.createElement("div",{id:n.type===ListBoxItemType.Header?"header-".concat(n.id):void 0,"aria-label":n.type===ListBoxItemType.Header?format(Resources.HeaderAriaLabel,n.text):void 0},renderListCell(i)))}function getHighlightedText(e,t,r){for(var n=[],l=-1,i=0;i<e.length;i++)-1!==t.indexOf(i)?n&&n[n.length-1]&&n[n.length-1].bold?n[l].text+=e.charAt(i):n[++l]={text:e.charAt(i),bold:!0}:n&&n[n.length-1]&&!n[n.length-1].bold?n[l].text+=e.charAt(i):n[++l]={text:e.charAt(i),bold:!1};for(var o=[],i=0;i<n.length;i++){var a=n[i];a.bold?o.push(React.createElement("span",{className:"font-weight-heavy",key:"".concat(e,"-").concat(i)},a.text)):o.push(a.text)}return React.createElement("span",{className:r},o)}export{Dropdown,filterItemByText,renderDropdownSelectedItemText,filterItems,filterTreeItems,filterMatchedItemByListboxType,renderHighlightedText,getHighlightedText};